// Scroll2 Object
// new version of the scroll object featuring horizontal scrolling and better code design
// 19990416

// Copyright (C) 1999 Dan Steinman
// Distributed under the terms of the GNU Library General Public License
// Available at http://www.dansteinman.com/dynduo/

function Scroll(x,y,width,height) {
	this.name = "Scroll"+(Scroll.count++)
	this.x = x
	this.y = y
	this.w = width
	this.h = height
	this.obj = this.name+"Object"
	eval(this.obj+"=this")
	this.makeObjects = ScrollMakeObjects
	this.build = ScrollBuild
	this.activate = ScrollActivate
	this.moveBars = ScrollWindowMoveBars
	this.moveWindowH = ScrollBarMoveWindowH
	this.moveWindowV = ScrollBarMoveWindowV
	this.setDimV = ScrollSetDimV
	this.setDimV(20,20,30)
	this.setDimH = ScrollSetDimH
	this.setDimV(20,20,30)
	this.setMargins = new Function()
	this.jumpTo = ScrollJumpTo
	this.load = ScrollLoad
	this.cornerImg = ""
	this.useV = true
	this.useH = false
}
function ScrollSetDimV(barW,arrowH,boxH) {
	this.dim = new Object()
	this.dim.barV = new Array(this.w,arrowH,barW,this.h-2*arrowH,barW,boxH)
	this.dim.up = new Array(this.w,0,barW,arrowH)
	this.dim.dn = new Array(this.w,this.h-arrowH,barW,arrowH)
}
function ScrollSetDimH(barH,arrowW,boxW) {
	this.dim.barH = new Array(arrowW,this.h,this.w-2*arrowW,barH,boxW,barH)
	this.dim.lt = new Array(0,this.h,arrowW,barH)
	this.dim.rt = new Array(this.w-arrowW,this.h,arrowW,barH)
}
function ScrollMakeObjects() {
	var a
	if (this.useV) {
	a=this.dim.barV; this.barV = new ScrollBar(a[0],a[1],a[2],a[3],a[4],a[5]);
	this.barV.onScroll = new Function(this.obj+'.moveWindowV()')
	a=this.dim.up; this.upImg = new ButtonImage(a[0],a[1],a[2],a[3]);
	a=this.dim.dn; this.dnImg = new ButtonImage(a[0],a[1],a[2],a[3]);
	this.upImg.onDown = new Function(this.obj+'.window.up()')
	this.upImg.onUp = new Function(this.obj+'.window.stop()')
	this.dnImg.onDown = new Function(this.obj+'.window.down()')
	this.dnImg.onUp = new Function(this.obj+'.window.stop()')
	}
	if (this.useH) {
	a=this.dim.barH; this.barH = new ScrollBar(a[0],a[1],a[2],a[3],a[4],a[5])
	this.barH.onScroll = new Function(this.obj+'.moveWindowH()')
	a=this.dim.lt; this.ltImg = new ButtonImage(a[0],a[1],a[2],a[3])
	a=this.dim.rt; this.rtImg = new ButtonImage(a[0],a[1],a[2],a[3])
	this.ltImg.onDown = new Function(this.obj+'.window.left()')
	this.ltImg.onUp = new Function(this.obj+'.window.stop()')
	this.rtImg.onDown = new Function(this.obj+'.window.right()')
	this.rtImg.onUp = new Function(this.obj+'.window.stop()')
	}
	this.window = new ScrollWindow(0,0,this.w,this.h)
	this.window.onScroll = new Function(this.obj+'.moveBars()')
}
function ScrollBuild() {
	this.window.build()
	this.css = css(this.name,this.x,this.y)+this.window.css
	if (this.cornerImg!="") this.css += css(this.name+'Corner',this.w,this.h,this.barV.w,this.barH.h)
	this.divStart = '<div id="'+this.name+'">'
	if (this.useV) {
		this.barV.build()
		this.upImg.build()
		this.dnImg.build()
		this.css += this.barV.css+this.upImg.css+this.dnImg.css
		this.divStart += this.barV.div+this.upImg.div+this.dnImg.div
	}
	if (this.useH) {
		this.barH.build()
		this.ltImg.build()
		this.rtImg.build()
		this.css += this.barH.css+this.ltImg.css+this.rtImg.css
		this.divStart += this.barH.div+this.ltImg.div+this.rtImg.div
	}
	if (this.cornerImg!="") this.divStart += '<div id="'+this.name+'Corner"><img src="'+this.cornerImg+'" width='+this.barV.w+' height='+this.barH.h+'></div>'
	this.divStart += this.window.divStart
	this.divEnd = this.window.divEnd+'</div>'
	this.div = this.divStart + this.divEnd
}
function ScrollActivate(w,h) {
	if (this.useV) {
	this.barV.activate()
	this.barV.boxlyr.moveTo(null,0)
	this.upImg.activate()
	this.dnImg.activate()
	}
	if (this.useH) {
	this.barH.activate()
	this.barH.boxlyr.moveTo(0,null)
	this.ltImg.activate()
	this.rtImg.activate()
	}
	this.window.activate(w,h)
	if (this.useV && !this.window.enableVScroll) this.barV.boxlyr.hide()
	else if (this.useV) this.barV.boxlyr.css.visibility = "inherit"
	if (this.useH && !this.window.enableHScroll) this.barH.boxlyr.hide()
	else if (this.useH) this.barH.boxlyr.css.visibility = "inherit"
}
function ScrollLoad(url) {
	this.window.load(url)
}
function ScrollJumpTo(x,y) {
	this.window.contentlyr.moveTo((x!=null)?Math.max(-x,-this.window.offsetWidth):null,(y!=null)?Math.max(-y,-this.window.offsetHeight):null)
	this.window.onScroll()
}
function ScrollWindowMoveBars() {
	if (this.useV && this.window.enableVScroll) this.barV.boxlyr.moveTo(null,this.window.getYfactor()*this.barV.offsetHeight)
	if (this.useH && this.window.enableHScroll) this.barH.boxlyr.moveTo(this.window.getXfactor()*this.barH.offsetWidth,null)
}
function ScrollBarMoveWindowV() {
	if (this.window.enableVScroll) this.window.contentlyr.moveTo(null,-this.barV.getYfactor()*(this.window.offsetHeight)+this.window.marginT)
}
function ScrollBarMoveWindowH() {
	if (this.window.enableHScroll) this.window.contentlyr.moveTo(-this.barH.getXfactor()*this.window.offsetWidth,null)
}
Scroll.count = 0
