// ScrollWindow Object
// a widget that draws layers that are to be scrolled, being built for a new Scroll Object
// 19990410

// Copyright (C) 1999 Dan Steinman
// Distributed under the terms of the GNU Library General Public License
// Available at http://www.dansteinman.com/dynduo/

function ScrollWindow(x,y,width,height) {
	this.name = "ScrollWindow"+(ScrollWindow.count++)
	this.x = x
	this.y = y
	this.w = width
	this.h = height
	this.border = 1
	this.borderColor = 'black'
	this.bgColor = null
	this.obj = this.name+"Object"
	eval(this.obj+"=this")
	this.setMargins = ScrollWindowSetMargins
	this.setMargins(0,0,0,0)
	this.history = new Array()
	this.historyLoc = -1
	this.historyLen = -1
	this.build = ScrollWindowBuild
	this.activate = ScrollWindowActivate
	this.up = ScrollWindowUp
	this.down = ScrollWindowDown
	this.left = ScrollWindowLeft
	this.right = ScrollWindowRight
	this.stop = ScrollWindowStop
	this.getXfactor = ScrollWindowGetXfactor
	this.getYfactor = ScrollWindowGetYfactor
	this.onScroll = new Function()
	this.load = ScrollWindowLoad
	this.reload = ScrollWindowReload
	this.back = ScrollWindowBack
	this.forward = ScrollWindowForward
	this.usebuffer = true
	this.inc = 10
	this.speed = 20
}
function ScrollWindowSetMargins(l,r,t,b) {
	this.marginL = l
	this.marginR = r
	this.marginT = t
	this.marginB = b
}
function ScrollWindowBuild() {
	var w = this.w
	var h = this.h
	var b = this.border
	var bc = this.borderColor
	var ml = this.marginL
	var mr = this.marginR
	var mt = this.marginT
	
	this.css = css(this.name,this.x,this.y,w,h,this.bgColor)+
	css(this.name+'Screen',b+ml,b,w-2*b-ml-mr,h-2*b)+
	css(this.name+'Content',0,mt,w-2*b-ml-mr)+
	css(this.name+'BorderT',0,0,w,b,bc)+
	css(this.name+'BorderB',0,h-b,w,b,bc)+
	css(this.name+'BorderL',0,0,b,h,bc)+
	css(this.name+'BorderR',w-b,0,b,h,bc)

	this.divStart = (is.ie && this.usebuffer)? '<IFRAME NAME="'+this.name+'Frame" WIDTH=0 HEIGHT=0 STYLE="display:none"></IFRAME>\n':''
	this.divStart += '<div id="'+this.name+'">\n'+
	'<div id="'+this.name+'Screen">\n'+
	'<div id="'+this.name+'Content" class="contentStyle">\n'
	
	this.divEnd = '</div>\n'+
	'</div>\n'+
	'<div id="'+this.name+'BorderT"></div>\n'+
	'<div id="'+this.name+'BorderB"></div>\n'+
	'<div id="'+this.name+'BorderL"></div>\n'+
	'<div id="'+this.name+'BorderR"></div>\n'+
	'</div>'
	this.div = this.divStart+this.divEnd
}
function ScrollWindowActivate(w,h) {
	if (is.ie && this.usebuffer && parent.frames[this.name+'Frame'].document.body.innerHTML) document.all[this.name+'Content'].innerHTML = parent.frames[this.name+'Frame'].document.body.innerHTML
	this.lyr = new DynLayer(this.name)
	this.screenlyr = new DynLayer(this.name+'Screen')
	this.contentlyr = new DynLayer(this.name+'Content')
	this.contentlyr.slideInit()
	this.contentlyr.onSlide = new Function(this.obj+'.onScroll()')
	if (h) this.contentHeight = h
	else this.contentHeight = (is.ns)? this.contentlyr.doc.height : this.contentlyr.elm.scrollHeight
	if (w) this.contentWidth = w
	else this.contentWidth = (is.ns)? this.contentlyr.doc.width : this.contentlyr.elm.scrollWidth
	if (is.ns) {
		this.contentlyr.css.clip.bottom = Math.max(this.contentHeight,this.h)
		this.contentlyr.css.clip.right = Math.max(this.contentWidth,this.w)
	}
	this.offsetHeight = this.contentHeight+this.marginT+this.marginB-this.screenlyr.h
	this.offsetWidth = this.contentWidth-this.screenlyr.w
	this.enableVScroll = (this.offsetHeight>0)
	this.enableHScroll = (this.offsetWidth>0)
}
function ScrollWindowLoad(url) {
	if (url != this.url) {
		this.historyLoc += 1
		this.historyLen = this.historyLoc
		this.history[this.historyLen] = url
	}
	this.reload()
}
function ScrollWindowBack() {
	if (this.historyLoc > 0) {
		this.historyLoc -= 1
		this.reload()
	}
}
function ScrollWindowForward() {
	if (this.historyLoc < this.historyLen) {
		this.historyLoc += 1
		this.reload()
	}
}
function ScrollWindowReload() {
	this.url = this.history[this.historyLoc]
	this.refresh = true
	this.contentlyr = new DynLayer(this.name+'Content')
	this.contentlyr.moveTo(0,this.marginT)
	if (is.ns) {
		this.contentlyr.elm.src = this.url
	}
	else if (is.ie) parent.frames[this.name+'Frame'].document.location = this.url
}
function ScrollWindowUp() {
	if (this.enableVScroll) this.contentlyr.slideTo(null,this.marginT,this.inc,this.speed)
}
function ScrollWindowDown() {
	if (this.enableVScroll) this.contentlyr.slideTo(null,-this.offsetHeight+this.marginT,this.inc,this.speed)
}
function ScrollWindowLeft() {
	if (this.enableHScroll) this.contentlyr.slideTo(0,null,this.inc,this.speed)
}
function ScrollWindowRight() {
	if (this.enableHScroll) this.contentlyr.slideTo(-this.offsetWidth,null,this.inc,this.speed)
}
function ScrollWindowStop() {
	this.contentlyr.slideActive = false
}
function ScrollWindowGetXfactor() {
	return (this.offsetWidth-this.contentlyr.x)/this.offsetWidth-1
}
function ScrollWindowGetYfactor() {
	return (this.offsetHeight-this.contentlyr.y+this.marginT)/this.offsetHeight-1
}
ScrollWindow.count = 0
